<?php
/**d
 * @package    hipayme payment module
 * @author     IdehPay
 * @copyright  2020  idehpay.com
 * @version    1.00
 */
@session_start();

if (isset($_GET['do']))
{
	include (dirname(__FILE__) . '/../../config/config.inc.php');
	include (dirname(__FILE__) . '/../../header.php');
	include_once (dirname(__FILE__) . '/hipayme.php');
	$hipayme = new hipayme;

	if ($_GET['do'] == 'payment')
	{
		$hipayme -> do_payment($cart);
	} else {
		if (isset($_GET['id']) && isset($_GET['amount']) && isset($_POST['Authority']) && isset($_POST['PaymentStatus']))
		{
			$orderId 	= $_GET['id'];
			$amount 	= $_GET['amount'];
	
			if (isset($_SESSION['order' . $orderId]))
			{
				$hash = Configuration::get('hipayme_HASH');
				$hash = md5($orderId . $amount . $hash);

				if ($hash == $_SESSION['order' . $orderId])
				{
					$MerchantID = Configuration::get('hipayme_API');
					$Authority 	= (isset($_POST['Authority']) && $_POST['Authority'] != "") ? $_POST['Authority'] : "";

					$curl = curl_init();
					curl_setopt($curl, CURLOPT_URL, 'http://hipayme.com/webservice/rest/PaymentVerification');
					curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type' => 'application/json'));
					curl_setopt($curl, CURLOPT_POSTFIELDS, "MerchantID={$MerchantID}&Amount={$amount}&Authority={$Authority}");
					curl_setopt($curl, CURLOPT_TIMEOUT, 30);
					curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
					curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
					$curl_exec = curl_exec($curl);
					curl_close($curl);

					$result = json_decode($curl_exec);

					if (isset($result->Status) && $result->Status == 100)
					{						
						error_reporting(E_ALL);
						$au = $Authority;
						$hipayme -> validateOrder($orderId, _PS_OS_PAYMENT_, $amount, $hipayme -> displayName, "سفارش تایید شده / کد رهگیری {$au}", array(), $cookie -> id_currency);
						$_SESSION['order' . $orderId] = '';
						Tools::redirect('history.php');
					} else {						
						echo $hipayme -> error($hipayme -> l('There is a problem.') . ' (' . $result->Status . ')<br/>' . $hipayme -> l('Authority code') . ' : ' . $Authority);
					}
				} else {
					echo $hipayme -> error($hipayme -> l('There is a problem.'));
				}
			} else {
				echo $hipayme -> error($hipayme -> l('There is a problem.'));
			}
		} else {
			echo $hipayme -> error($hipayme -> l('There is a problem.'));
		}
	}
	include_once (dirname(__FILE__) . '/../../footer.php');
} else {
	_403();
}
function _403() {
	header('Status: 403 Forbidden');
	header('HTTP/1.1 403 Forbidden');
	exit();
}